/*
FVR_RONDOUDOU_DEMO
V.Final
september/2003
http://www.fvring.com
-----------------------------------------------------------------------------
Autor : 				Fonzie Voltonov
Dev. from :				Modified from Paul Lee DEMOS
Lib. from :				Modified from KANEDA lib.
-----------------------------------------------------------------------------
Working on real hardware :	no
Source code complete :		yes
Demo finished :			yes
Include needed :			possible fvrlib.h (just for some symbol def.)
-----------------------------------------------------------------------------
Notes: 
-This code is a demo made without any lib.
-This was my firts prog attemp (in C and for the sega console) so the 
code is very ugly and the VDP reg are wrong.
Beginners notes:
-The variables witch are defined out of the main() are static (on ROM).
This is due to a SGCC bug, sorry.
-Dont try to modify this demo, the code is so ugly.
Real hardware notes:
-You need to fix header(rom lenght) to get a
working rom on real hardware.
-The real hardware make this demo crash (maybe because the VDP reg are wrong)

*/

#include "fvrlib.h"

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Function prototypes.
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void init_gfx();
   void load_tiles_m();
   void set_colors_m();
   void affichage_fvrb();
   void affichage_text();
   void affichage_sprite();
   void play_with_scrolls();
   void replace_fvring_by_coconuts();
   void play_with_joypads();


/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Variables externes.
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

  extern ulong fvrb320[]; 
  extern ulong tiledata[];
  extern ulong rondoudou[];
  extern ulong mic[];
  extern ulong coconuts[];
  extern ulong white[];
  extern ulong mouche1[];
  extern ulong mouche2[];
  extern ulong shadow[];
  extern ulong hightlight[];


/* char texte1[]=" !\"#$%&'()*+,-./0123456789 :;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~  */
  char texte1[]="Rondoudou's (Jigglypuff) battle game(?).>>http://www.fvring.com (Fonzie V.).    Many thanks to: Paul Lee, Kaneda, Mike  Pavone, Charles Mc Donald ...                                 "; 
               /*0123456789012345678901234567890123456789#123456789012345678901234567890123456789#123456789012345678901234567890123456789#123456789012345678901234567890123456789#123456789012345678901234567 890123456789#1234 56789012345678901234567890123456789#1234567890123456789012 34567890123456 789#123456789012345678901234567890123456789*/
 char message[]="00010203040506070809101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960FF::"; 
 char messagep1[]="~~P1 WIN~~ "; 
 char messagep2[]="~~P2 WIN~~ "; 
  char messagegame[]="~THE GAME~ "; 
  char messagep2start[]="P2 PRESS START ";   

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction principale.
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

void main()
   {
   while(1)
    {
    /* Initialize Genesis GFX registers */
      init_gfx();

    /*DMA */
     dma_vram_copy(tiledata, 0, 128 * 32);
   
    /* Load the character set */
      load_tiles_m();
   
    /* Set colors */
      set_colors_m();
   
    /* Affichage */
      affichage_fvrb();

    /* Affichage */
      affichage_text();

    /* Affichage */
      affichage_sprite();

    /* Scrolls */
      play_with_scrolls();

    /* Scrolls */
     replace_fvring_by_coconuts();

    /* Scrolls */
      play_with_joypads();

      RAZ();

    }


   }

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "Init_gfx".
Dont look at this func, the reg are so wrong...
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void init_gfx()
   {
      register uint *pw;
   
      pw = (uint *) GFXCNTL;
   
      *pw = 0x8016;   /* reg. 0 - Enable HBL */
      *pw = 0x8174;   /* reg. 1 - Enable VBL */
      *pw = 0x8230;   /* reg. 2 - Plane A =$30*$400=$C000 */
      *pw = 0x832C;   /* reg. 3 - Window  =$2C*$400=$B000 */
      *pw = 0x8407;   /* reg. 4 - Plane B =$7*$2000=$E000 */
      *pw = 0x855E;   /* reg. 5 - sprite table begins at $BC00=$5E*$200 < must be 5f in 256 */
      *pw = 0x8600;   /* reg. 6 */
      *pw = 0x8700;   /* reg. 7 BGcolor*/
      *pw = 0x8801;   /* reg. 8 */
      *pw = 0x8901;   /* reg. 9 */
      *pw = 0x8a01;   /* reg. 10 */
      *pw = 0x8b00;   /* reg. 11 */
      *pw = 0x8c89;   /* reg. 12 modif de la largeur d'affichage avant: 8c08 */
      *pw = 0x8d2E;   /* reg 13 - HScoll Table = $B800 */
      *pw = 0x8E00;   /* reg 14 */
      *pw = 0x8f02;    /* reg. 15 */
      *pw = 0x9001;   /* reg. 16 //// modif de la largeur de mmoire avant : 9000 */
      *pw = 0x9100;   /* reg. 17 */
      *pw = 0x9200;   /* reg. 18 */
      *pw = 0x9300;   /* reg. 19 */
      *pw = 0x9400;   /* reg. 20 */
      *pw = 0x9500;   /* reg. 21 */
      *pw = 0x9600;   /* reg. 22 */
   }

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "load_tiles".
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void load_tiles_m()
   {
      register ulong *pl;
      register uint i;
   
/*---------------------------------------------- load tiles fvring 	*/ 
	pl = (ulong *) GFXCNTL;
	*pl = GFX_WRITE_ADDR(0x0);
	pl = (ulong *) GFXDATA;
	for (i = 0; i < 1120 * 8; i++)
	*pl =  fvrb320[i];
/*---------------------------------------------- load tiles texte 1/1	*/ 
	pl = (ulong *) GFXCNTL;
	*pl = GFX_WRITE_ADDR(0x8C00);
	pl = (ulong *) GFXDATA;
	for (i = 0; i < 128 * 8; i++)
	*pl = tiledata[i];
/*---------------------------------------------- load tiles sprite rondoudou 1/1	*/ 
	pl = (ulong *) GFXCNTL;
	*pl = GFX_WRITE_ADDR(0xA000);
	pl = (ulong *) GFXDATA;
	for (i = 0; i < 10 * 8; i++)
	*pl = rondoudou[i];
/*---------------------------------------------- load tiles sprite mic 1/1	*/ 
	pl = (ulong *) GFXDATA;
	for (i = 0; i < 10 * 8; i++)
	*pl = mic[i];
/*---------------------------------------------- load tiles mouche 1et2	*/
	pl = (ulong *) GFXDATA;
	for (i = 0; i < 1 * 8; i++)
	*pl = mouche1[i]; 
	pl = (ulong *) GFXDATA;
	for (i = 0; i < 1 * 8; i++)
	*pl = mouche2[i]; 
/*---------------------------------------------- load tiles shadow 1et2	*/
	pl = (ulong *) GFXDATA;
	for (i = 0; i < 10 * 8; i++)
	*pl = shadow[i]; 
/*---------------------------------------------- load tiles hightlight 1et2	*/
	pl = (ulong *) GFXDATA;
	for (i = 0; i < 1 * 8; i++)
	*pl = hightlight[i]; 
/*---------------------------------------------- load tiles white	*/ 
	pl = (ulong *) GFXCNTL;
	*pl = GFX_WRITE_ADDR(0x4600);
	pl = (ulong *) GFXDATA;
	for (i = 0; i < 1 * 8; i++)
	*pl =  white[i];


   }

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "set_colors".
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void set_colors_m()
   {
      register ulong *pl;
      register uint *pw;
   
/*Dfinition de la premiere palette fvring*/
      pl = (ulong *) GFXCNTL;
      *pl = GFX_COLOR_WRITE_ADDR(0);
      pw = (uint *) GFXDATA;
   
      *pw = 0x0b71;		/* color 0 - tran bleu */
      *pw = 0x0d81;		/* color 1 - white */
      *pw = 0x0000;		/* color 2 - black */
      *pw = 0x0f92;		/* color 3 - bleu */
      *pw = 0x0a85;		/* color 4 - bleu */
      *pw = 0x0fa4;		/* color 5 - bleu */
      *pw = 0x0eb9;		/* color 6 -bleu */
      *pw = 0x0edc;		/* color 7 - bleu */
      *pw = 0x0fdc;		/* color 8 - bleu */
      *pw = 0x0fec;		/* color 9 - bleu */
      *pw = 0x0b71;		/* color A - bleu */ 
      *pw = 0x0fee;		/* color B - bleu */
      *pw = 0x0fff;		/* color C - bleu */
      *pw = 0x0fff;		/* color D - bleu */
      *pw = 0x0fff;		/* color E - bleu */
      *pw = 0x0000;		/* color F - black */


/*Dfinition de la seconde palette text*/
      pl = (ulong *) GFXCNTL;
      *pl = GFX_COLOR_WRITE_ADDR(32);
      pw = (uint *) GFXDATA;
   
      *pw = 0x0000;		/* color 0 - tran bleu */
      *pw = 0x0000;		/* color 1 - white */
      *pw = 0x0000;		/* color 2 - black */
      *pw = 0x0000;		/* color 3 - bleu */
      *pw = 0x0000;		/* color B - bleu */
      *pw = 0x0000;		/* color C - bleu */
      *pw = 0x0000;		/* color D - bleu */
      *pw = 0x0000;		/* color E - bleu */
      *pw = 0x0000;		/* color F - black */
      *pw = 0x0000;		/* color 4 - bleu */
      *pw = 0x0000;		/* color 5 - bleu */
      *pw = 0x0000;		/* color 6 -bleu */
      *pw = 0x0000;		/* color 7 - bleu */
      *pw = 0x0000;		/* color 8 - bleu */
      *pw = 0x0000;		/* color 9 - bleu */
      *pw = 0x0000;		/* color A - bleu */ 

/*Dfinition de la 3eme palette (rondoudou&&mic)*/
      pl = (ulong *) GFXCNTL;
      *pl = GFX_COLOR_WRITE_ADDR(64);
      pw = (uint *) GFXDATA;
   
      *pw = 0x0f0f;		/* color 0 - tran bleu */
      *pw = 0x043d;		/* color 1 - white */
      *pw = 0x065e;		/* color 2 - black */
      *pw = 0x0000;		/* color 3 - bleu */
      *pw = 0x098f;		/* color 4 - bleu */
      *pw = 0x0a9f;		/* color 5 - bleu */
      *pw = 0x0aaf;		/* color 6 - bleu */
      *pw = 0x0bbf;		/* color 7 - bleu */
      *pw = 0x0ddf;		/* color 8 - black */
      *pw = 0x0fff;		/* color 9 - bleu */
      *pw = 0x0000;		/* color A - bleu */
      *pw = 0x0999;		/* color B -bleu */
      *pw = 0x0540;		/* color C - bleu */
      *pw = 0x0000;		/* color D - bleu */
      *pw = 0x0a60;		/* color E - bleu */
      *pw = 0x0000;		/* color F - bleu */ 

/*Dfinition de la 4eme palette (coco)*/
      pl = (ulong *) GFXCNTL;
      *pl = GFX_COLOR_WRITE_ADDR(96);
      pw = (uint *) GFXDATA;
   
      *pw = 0x0000;		/* color 0 - tran bleu */
      *pw = 0x0f11;		/* color 1 - white 0c10*/
      *pw = 0x0ff0;		/* color 2 - black */
      *pw = 0x0f11;		/* color 3 - bleu */
      *pw = 0x0141;		/* color 4 - bleu */
      *pw = 0x0f41;		/* color 5 - bleu */
      *pw = 0x0171;		/* color 6 - bleu */
      *pw = 0x01b1;		/* color 7 - bleu */
      *pw = 0x0049;		/* color 8 - black */
      *pw = 0x01e1;		/* color 9 - bleu */
      *pw = 0x0f74;		/* color A - bleu */
      *pw = 0x0fc6;		/* color B -bleu */
      *pw = 0x06f9;		/* color C - bleu */
      *pw = 0x0ffe;		/* color D - bleu */
      *pw = 0x0fff;		/* color E - bleu */
      *pw = 0x0010;		/* color F - bleu */ 

   }


/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "affichage_fvrb".
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void affichage_fvrb()
   {
      register ulong *pl;
      register uint *pw;
      register uint i;   
      register uint nboftiles;
  
 
/*Display sur plane A*/
      pl = (ulong *) GFXCNTL;
      *pl = GFX_WRITE_ADDR(0xe000);
       
      nboftiles=0;

      pw = (uint *) GFXDATA;
      for (i = 0; i < 1120; i++)
	{
	    if (nboftiles==40)
	    {
	      nboftiles=0;
	      i--;

	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000;
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	    }
	    else
	    {
	       nboftiles++;
                     *pw = 0x8000  + i; /*+ (palnb << 13)*/
                  }
	}
}
/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "affichage_text".
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void affichage_text()
   {
      register ulong *pl;
      register uint *pw;
      register uint i,k;   
      register uint ttexte;
      register uint nboftiles;

     ttexte=150;
     /*Display sur plane B*/
     nboftiles=0;
      pl = (ulong *) GFXCNTL;
      *pl = GFX_WRITE_ADDR(0xC280);

      pw = (uint *) GFXDATA;
      for (i = 0; i < ttexte; i++)
      {	
	    if (nboftiles==40)
	    {
	    nboftiles=0;
          i--;
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000;
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
	   *pw = 0x80000; 
         *pw = 0x80000;
	    }
	    else
	    {
	     nboftiles++;
                   if(texte1[i]<0x60)
                   {k=32;}
                   else
                   {k=0;}
                  *pw = 0x8000 + (texte1[i]-k)+0x460 + (1 << 13); 
	     }
      }
 
  }

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "affichage_sprite".
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void affichage_sprite()
   {

  }

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "play_with_scrolls".
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void play_with_scrolls()
   {
     register uint *pw;
     register ulong *pl;

      pw = (uint *) GFXDATA;
      pl = (ulong *) GFXCNTL;

      
         /* GFX scroll plane A */
         *pl = GFX_VERT_SCROLL(0xC000);
         *pw = 72;
  wait_sync(100);
   }

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "replace_fvring_by_coconuts".
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void replace_fvring_by_coconuts()
   {
      register ulong *pl;
      register uint *pw;
      register uint i,nboftiles,z;



      /*desaffichage progressif du fvring, unlol*/
      /*Display sur plane A*/
      pl = (ulong *) GFXCNTL;
      *pl = GFX_WRITE_ADDR(0xe000);
       
      nboftiles=0;

      pw = (uint *) GFXDATA;
      for (i = 0,z=0; i < 1120; i++,z++)
	{
	    if (nboftiles==40)
	    {
	      nboftiles=0;
	      i--;

	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000;
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	    }
	    else
	    {
                     nboftiles++;
                     *pw = 0x8000  + 880; /*+ (palnb << 13)*/
                  }
                  if(z>20)
                   {
                    z=0;
                    wait_sync(1);
                   }

            }

      
      /*Chargement de coconut en mmoire, lol*/
        pl = (ulong *) GFXCNTL;
        *pl = GFX_WRITE_ADDR(0x0);
        pl = (ulong *) GFXDATA;
           for (i = 0; i < 560 * 8; i++)
	{*pl =  coconuts[i];}

      /*affichage progressif du coconuts, unlol*/
      /*Display sur plane A*/
      pl = (ulong *) GFXCNTL;
      *pl = GFX_WRITE_ADDR(0xe000);
       
      nboftiles=0;

      pw = (uint *) GFXDATA;
      for (i = 0,z=0; i < 1120; i++,z++)
	{
	    if (nboftiles==40)
	    {
	      nboftiles=0;
	      i--;

	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000;
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	     *pw = 0x8000; 
	    }
	    else
	    {
                     if(i<560)
                       {
	          nboftiles++;
                        *pw = 0x8000  + 1 + (3 << 13);
                       }
                     else
                       {
	          nboftiles++;
                        *pw = 0x8000  + i-560 + (3 << 13);
                       }
                  }
                  if(z>20)
                   {
                    z=0;
                    wait_sync(1);
                   }

            }

   /*changement de la palette texte*/

      pl = (ulong *) GFXCNTL;
      *pl = GFX_COLOR_WRITE_ADDR(32);
      pw = (uint *) GFXDATA;
   
      *pw = 0x0000;		/* color 0 - tran bleu */
      *pw = 0x0000;		/* color 1 - white */
      *pw = 0x0FFF;		/* color 2 - black */
      *pw = 0x0000;		/* color 3 - bleu */
      *pw = 0x0000;		/* color B - bleu */
      *pw = 0x0000;		/* color C - bleu */
      *pw = 0x0000;		/* color D - bleu */
      *pw = 0x0000;		/* color E - bleu */
      *pw = 0x0000;		/* color F - black */
      *pw = 0x0000;		/* color 4 - bleu */
      *pw = 0x0000;		/* color 5 - bleu */
      *pw = 0x0000;		/* color 6 -bleu */
      *pw = 0x0000;		/* color 7 - bleu */
      *pw = 0x0000;		/* color 8 - bleu */
      *pw = 0x0000;		/* color 9 - bleu */
      *pw = 0x0000;		/* color A - bleu */ 
   }

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Fonction "play_with_joypads".
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

   void play_with_joypads()
   {
    register uint posx,posy,posy2,posx2,posx3,posy3,enable,p1e,p2e;
    register uint *pw;
    register ulong *pl;
    register uchar result,result2;
    register uint i,blink,tempssec,loop,tempsmin,automode,automodestep,k,kl,rotate,pointsp1,pointsp2,stop,starsx1,starsy1,starsx2,starsy2,starsx4,starsy4,starsx5,starsy5,starsx3,starsy3,pointspasses,starsp1,starsp2,jumpp1,jumpp2,stjumpp1,stjumpp2,rotate2,posxmouche,posxmouche2;



    posx=150;
    posy=327;

    posx2=400;
    posy2=327;

    posxmouche=50;
    posxmouche2=50;

    blink=0;
    p1e=0;
    p2e=0;

    starsx1=0;
    starsx2=0;
    starsx3=0;
    starsx4=0;
    starsx5=0;
    starsy1=0;
    starsy2=0;
    starsy3=0;
    starsy4=0;
    starsy5=0;

    tempsmin=0;
    tempssec=0;
    rotate=0;
    rotate2=0;
     
    pointsp1=0;
    pointsp2=0;
    pointspasses=0;

    starsp1=0;
    starsp2=0;

    jumpp1=0;
    jumpp2=0;
    stjumpp1=0;
    stjumpp2=0;
    stop=0;
    automode=1;
    automodestep=0;

    loop=0;
    while(loop==0)
     {

     result=read_joypad1();
     result2=read_joypad2();

          if (result2!=BUTTON_S && automode==1 && stop==0)/*Mode auto enabled*/
            {
               if(p2e==1 && enable!=1) /*Le joueur 2  la balle*/
                  {
                   if((posx2-posx)+500>500)   /*Le joueur 2 est dans son camp*/
                    {
                       if(result==BUTTON_B && rotate==20)
                        {
                         result2=BUTTON_A;
                        }
                       else
                        {
                         result2=JOY_RIGHT+BUTTON_B; 
                          if (rotate==10)
                           {
                            result2=BUTTON_A;
                           }
                        }                    
                    }
                   else if((posx2-posx)+500<500) /*Le joueur 2 n'est pas dans son camp*/
                    {
                      if(posx2>175) /*Le joueur 2 est loin du but adverse*/
                       {
                        result2=JOY_LEFT;
                       }
                      else /*Le joueur 2 est pres du but adverse*/
                       {
                        result2=BUTTON_A+JOY_LEFT;
                       }
                    }
                  }
                else if(p1e==1 && enable!=1) /*Le joueur 1  la balle*/
                  {
                   if((posx2-posx)+500>510)   /*Le joueur 1 est dans son camp*/
                    {
                      if(posy<313 && ((posx2-posx3)+500)<560)
                       {
                        result2=BUTTON_B+JOY_RIGHT;
                       }
                      else
                       {
                         if(tempssec>30)
                           {
                           result2=JOY_LEFT;
                           }
                          else
                           {
                           result2=JOY_RIGHT;
                           }
                       }
                    }
                   else if((posx2-posx)+500<490)/*Le joueur 1 n'est pas dans son camp*/
                    {
                      if(posx<370) /*Le joueur 1 est loin du but adverse*/
                       {
                        result2=JOY_RIGHT;
                       }
                      else /*Le joueur 1 est pres du but adverse*/
                       {
                         if(posx2>=270)/*Le joueur 2 est a droite du point mic*/
                           {
                           result2=JOY_LEFT;
                           }
                         else/*Le joueur 2 est a gauche du point mic*/
                           {
                           result2=JOY_RIGHT;
                           }
                       }
                    }
                   else if(rotate==20 || rotate==40) /*Le joueur 1 est au dessus du p2*/
                    {
                           result2=BUTTON_B;
                    }
                  }
                 else if (p1e==1) /*le joueur1 lance*/
                  {
                   if(((posx2-posx)+500)<500) /*le joueur 1 gagne forcment*/
                    {
                         if(posx2>=270)/*Le joueur 2 est a droite du point mic*/
                           {
                           result2=JOY_LEFT;
                           }
                         else/*Le joueur 2 est a gauche du point mic*/
                           {
                           result2=JOY_RIGHT;
                           }
                    }
                   else /*le joueur 1 ne gagne pas forcment*/
                    {
                      if((posy3<316)&&(posy3>270) && ((posx2-posx3)+500)<540)
                        {
                          result2=JOY_RIGHT+BUTTON_B;                       
                        }
                      else if((posy3<270) && ((posx2-posx3)+500)<585)
                        {
                          result2=JOY_RIGHT+BUTTON_B;                         
                        }
                      else
                        {
                          result2=JOY_RIGHT;                       
                        }
                    }
                  }
                 else /*personne n'a la balle*/
                  {
                   if((posx2-posx3)+500<500)   /*Le joueur 2 est a gauche du mic*/
                    {
                    result2=JOY_RIGHT;
                    }  
                   else if((posx2-posx3)+500>500)   /*Le joueur 2 est a droite du mic*/
                    {
                    result2=JOY_LEFT;
                    }        
                   else if(rotate==20 || rotate==40)
                    {
                    result2=BUTTON_B;
                    }
                  }
            }

        switch (result)
        {
         case BUTTON_A :
         case BUTTON_A+JOY_LEFT:
         case BUTTON_A+JOY_RIGHT:
         case BUTTON_A+JOY_UP :
         case BUTTON_A+JOY_DOWN :
         case BUTTON_A+JOY_UP+JOY_LEFT:
         case BUTTON_A+JOY_UP+JOY_RIGHT:
         case BUTTON_A+JOY_DOWN+JOY_LEFT :
         case BUTTON_A+JOY_DOWN+JOY_RIGHT:
         if(p1e==1)
         {enable=1;}
         break;
         case BUTTON_B :
         case BUTTON_B+JOY_LEFT:
         case BUTTON_B+JOY_RIGHT:
         case BUTTON_B+JOY_UP :
         case BUTTON_B+JOY_DOWN :
         case BUTTON_B+JOY_UP+JOY_LEFT:
         case BUTTON_B+JOY_UP+JOY_RIGHT:
         case BUTTON_B+JOY_DOWN+JOY_LEFT :
         case BUTTON_B+JOY_DOWN+JOY_RIGHT:
         if(stjumpp1<1)
         {stjumpp1=1;}
         break;
         case BUTTON_S:
         /*start*/
          if(stop==1 && rotate==3)
            {stop=2;}
          else if (rotate==30)
            {stop=1;}
         break;
         default:

         break;
        }

        switch (result2)
        {
         case BUTTON_A :
         case BUTTON_A+JOY_LEFT:
         case BUTTON_A+JOY_RIGHT:
         case BUTTON_A+JOY_UP :
         case BUTTON_A+JOY_DOWN :
         case BUTTON_A+JOY_UP+JOY_LEFT:
         case BUTTON_A+JOY_UP+JOY_RIGHT:
         case BUTTON_A+JOY_DOWN+JOY_LEFT :
         case BUTTON_A+JOY_DOWN+JOY_RIGHT:
         if(p2e==1)
         {enable=1;}
         break;
         case BUTTON_B :
         case BUTTON_B+JOY_LEFT:
         case BUTTON_B+JOY_RIGHT:
         case BUTTON_B+JOY_UP :
         case BUTTON_B+JOY_DOWN :
         case BUTTON_B+JOY_UP+JOY_LEFT:
         case BUTTON_B+JOY_UP+JOY_RIGHT:
         case BUTTON_B+JOY_DOWN+JOY_LEFT :
         case BUTTON_B+JOY_DOWN+JOY_RIGHT:
         if(stjumpp2<1)
         {stjumpp2=1;}
         break;
         case BUTTON_S:
         /*start*/
          stop=3;
         break;
         default:

         break;
        }
/*Si start est pas enfonc*/
if(stop==0)
{

        switch (result)
        {
         case JOY_LEFT:
         case JOY_LEFT + BUTTON_A:
         case JOY_LEFT + BUTTON_B:
         if(posx>120)
         {
         posx--;
         posx--;
         }
         break;
         case JOY_RIGHT:
         case JOY_RIGHT + BUTTON_A:
         case JOY_RIGHT + BUTTON_B:
         if(posx<380)
         {
         posx++;
         posx++;
         }
         break;
         default:
         break;
        }

        switch (result2)
        {
         case JOY_LEFT:
         case JOY_LEFT + BUTTON_A:
         case JOY_LEFT + BUTTON_B:
         if(posx2>170)
         {
         posx2--;
         posx2--;
         }
         break;
         case JOY_RIGHT:
         case JOY_RIGHT + BUTTON_A:
         case JOY_RIGHT + BUTTON_B:
         if(posx2<430)
         {
         posx2++;
         posx2++;
         }
         break;
         default:
         break;
        }


if(p1e==1)
{
    if((posx3>posx2-10 && posx3<posx2+15) && (posy3>posy2-10 && posy3<posy2+15))
      {
      enable=0;
      p1e=0;
      p2e=1;
      pointspasses++;
      }
     else
      {
     if(enable==1)
       {
        posx3++;
        posx3++;
        posx3++;
        posx3++;
        posx3++;
         if(posx3>600)
           {
           enable=0;
           p1e=0;
           pointsp1=pointsp1+pointspasses+1;
           pointspasses=0;
           }
       }
     else
       {
       posx3=posx+4;
       posy3=posy+4;
       }
      }
}
else if(p2e==1)
{
    if((posx3>posx-10 && posx3<posx+15) && (posy3>posy-10 && posy3<posy+15))
      {
      enable=0;
      p1e=1;
      p2e=0;
      pointspasses++;
      }
     else
     {
     if(enable==1)
       {
        posx3--;
        posx3--;
        posx3--;
        posx3--;
        posx3--;
         if(posx3<10)
           {
           enable=0;
           p2e=0;
           pointsp2=pointsp2+pointspasses+1;
           pointspasses=0;
           }
       }
     else
       {
       posx3=posx2+4;
       posy3=posy2+4;
       }
     }
}
else
{
    if((posx3>posx-10 && posx3<posx+15) && (posy3>posy-10 && posy3<posy+15))
      {
      p1e=1;
      p2e=0;
      blink=0;
      }
     else if((posx3>posx2-10 && posx3<posx2+15) && (posy3>posy2-10 && posy3<posy2+15))
      {
      p1e=0;
      p2e=1;
      blink=0;
      }
     else
      {
       posx3=270;
       posy3=225;
          if(blink==0)
            {blink=1;}
          else
            {blink=0;}
      }
}


 /*display lol((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((*/


     if (stjumpp1==1)
        {
        jumpp1++;
        jumpp1++;
        jumpp1++;
        jumpp1++;
        posy--;
        posy--;
        posy--;
        posy--;
        }
     else if (stjumpp1==2)
        {
        jumpp1--;
        jumpp1--;
        jumpp1--;
        jumpp1--;
        posy++;
        posy++;
        posy++;
        posy++;
        }

     if(jumpp1>100)
       {stjumpp1=2;}
     else if (jumpp1<1) 
        {stjumpp1=0;
          posy=327;
        }


     if (stjumpp2==1)
        {
        jumpp2++;
        jumpp2++;
        jumpp2++;
        jumpp2++;
        posy2--;
        posy2--;
        posy2--;
        posy2--;
        }
     else if (stjumpp2==2)
        {
        jumpp2--;
        jumpp2--;
        jumpp2--;
        jumpp2--;
        posy2++;
        posy2++;
        posy2++;
        posy2++;
        }

     if(jumpp2>100)
       {stjumpp2=2;}
     else if (jumpp2<1) 
        {stjumpp2=0;
          posy2=327;
        }

     pl = (ulong *) GFXCNTL;
     *pl = GFX_WRITE_ADDR(0xBC00);
     pw = (uint *) GFXDATA;


/*Affichage mouche &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
     rotate2++;
     if(rotate2>4)
       {
        rotate2=0;

        posxmouche2++;
        posxmouche2++;
         if(posxmouche2>600)
          {posxmouche2=50;}
        posxmouche++;
         if(posxmouche>600)
          {posxmouche=50;}
        }




      if(rotate2>2)
         {
         *pw = 200; /*ypos*/
         *pw = 0x0 | 1;   /*taille et id*/
         *pw = 0xE514; /*pak adr, flip...1110010100010100*/ 
         *pw = posxmouche; /*xpos*/

         *pw = 190; /*ypos*/
         *pw = 0x0 | 2;   /*taille et id*/
         *pw = 0xE515; /*pak adr, flip...1110010100010100*/ 
         *pw = posxmouche-20; /*xpos*/

         *pw = 210; /*ypos*/
         *pw = 0x0 | 3;   /*taille et id*/
         *pw = 0xE514; /*pak adr, flip...1110010100010100*/ 
         *pw = posxmouche2; /*xpos*/

         *pw = 150; /*ypos*/
         *pw = 0x0 | 4;   /*taille et id*/
         *pw = 0xE515; /*pak adr, flip...1110010100010100*/ 
         *pw = posxmouche2-20; /*xpos*/
         }
      else
         {
         *pw = 200; /*ypos*/
         *pw = 0x0 | 1;   /*taille et id*/
         *pw = 0xE515; /*pak adr, flip...1110010100010101*/ 
         *pw = posxmouche; /*xpos*/

         *pw = 190; /*ypos*/
         *pw = 0x0 | 2;   /*taille et id*/
         *pw = 0xE514; /*pak adr, flip...1110010100010101*/ 
         *pw = posxmouche-20; /*xpos*/

         *pw = 210; /*ypos*/
         *pw = 0x0 | 3;   /*taille et id*/
         *pw = 0xE515; /*pak adr, flip...1110010100010101*/ 
         *pw = posxmouche2; /*xpos*/

         *pw = 150; /*ypos*/
         *pw = 0x0 | 4;   /*taille et id*/
         *pw = 0xE514; /*pak adr, flip...1110010100010101*/ 
         *pw = posxmouche2-20; /*xpos*/
         }

/*Affichage mic &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
     if (blink==0)
     {   
     *pw = posy3; /*ypos*/
     *pw = 0xA00 | 5;   /*taille et id*/
     *pw = 0xC50A; /*pak adr, flip...1100010100001010*/ 
     *pw = posx3; /*xpos*/
     }
     else
     {   
     *pw = posy3+300; /*ypos*/
     *pw = 0xA00 | 5;   /*taille et id*/
     *pw = 0xC50A; /*pak adr, flip...1100010100001010*/ 
     *pw = posx3+300; /*xpos*/
     }

/*Affichage rondoudous &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/

     *pw = posy; /*ypos*/
     *pw = 0xA00 | 6;   /*taille et id*/
     *pw = 0xCD00; /*pak adr, flip...1100010100000000*/ 
     *pw = posx; /*xpos*/


     *pw = posy2; /*ypos*/
     *pw = 0xA00 | 7;   /*taille et id*/
     *pw = 0xC500; /*pak adr, flip...1100010100000000*/ 
     *pw = posx2; /*xpos*/

/*Affichage shadow &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/

     *pw = 330; /*ypos*/
     *pw = 0xA00 | 8;   /*taille et id*/
     *pw = 0xE516; /*pak adr, flip...1110010100010110*/ 
     *pw = posx2; /*xpos*/
      
     *pw = 330; /*ypos*/
     *pw = 0xA00 | 9;   /*taille et id*/
     *pw = 0xE516; /*pak adr, flip...1110010100010110*/ 
     *pw = posx; /*xpos*/

     *pw = 330; /*ypos*/
     *pw = 0xA00 | 10;   /*taille et id*/
     *pw = 0xE516; /*pak adr, flip...1110010100010110*/ 
     *pw = posx3; /*xpos*/

/*Affichage stars &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/

     if(starsx1==0)
       {if(rotate==1){starsx1=posx3;starsy1=posy3;}}
     else if (starsy1>330)
       {starsx1=0;starsy1=0;} 
     else
       {starsy1++;}    

     if(starsx2==0)
       {if(rotate==10){starsx2=posx3;starsy2=posy3;}}
     else if (starsy2>330)
       {starsx2=0;starsy2=0;} 
     else
       {starsy2++;}   

     if(starsx3==0)
       {if(rotate==20){starsx3=posx3;starsy3=posy3;}}
     else if (starsy3>330)
       {starsx3=0;starsy3=0;} 
     else
       {starsy3++;} 

     if(starsx4==0)
       {if(rotate==30){starsx4=posx3;starsy4=posy3;}}
     else if (starsy4>330)
       {starsx4=0;starsy4=0;} 
     else
       {starsy4++;} 

     if(starsx5==0)
       {if(rotate==40){starsx5=posx3;starsy5=posy3;}}
     else if (starsy5>330)
       {starsx5=0;starsy5=0;} 
     else
       {starsy5++;} 

         *pw = starsy1+10; /*ypos*/
         *pw = 0x0 | 11;   /*taille et id*/
         *pw = 0xE520; /*pak adr, flip...1110010100100000*/ 
         *pw = starsx1+10; /*xpos*/

         *pw = starsy2+10; /*ypos*/
         *pw = 0x0 | 12;   /*taille et id*/
         *pw = 0xE520; /*pak adr, flip...1110010100100000*/ 
         *pw = starsx2+10; /*xpos*/

         *pw = starsy3+10; /*ypos*/
         *pw = 0x0 | 13;   /*taille et id*/
         *pw = 0xE520; /*pak adr, flip...1110010100100000*/ 
         *pw = starsx3+15; /*xpos*/

         *pw = starsy4+10; /*ypos*/
         *pw = 0x0 | 14;   /*taille et id*/
         *pw = 0xE520; /*pak adr, flip...1110010100100000*/ 
         *pw = starsx4+10; /*xpos*/
      
         *pw = starsy5+10; /*ypos*/
         *pw = 0x0 | 15;   /*taille et id*/
         *pw = 0xE520; /*pak adr, flip...1110010100100000*/ 
         *pw = starsx5+15; /*xpos*/

/*Calcul & Affichage heure &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
      rotate++;
      if(rotate>50)
        {
         tempssec++;
          if(tempssec>60)
            {tempssec=0;
              tempsmin++;
            }
         rotate=1;
        }

       if(tempsmin==1 && tempssec==0)
           {
                  /*Dfinition de la 4eme palette (coco)*/
      		pl = (ulong *) GFXCNTL;
      		*pl = GFX_COLOR_WRITE_ADDR(96);
      		pw = (uint *) GFXDATA;
   
      		*pw = 0x0000;		/* color 0 - tran bleu */
      		*pw = 0x0b0d;		/* color 1 - white 0c10*/
      		*pw = 0x0f03;		/* color 2 - black */
      		*pw = 0x0d1f;		/* color 3 - bleu */
      		*pw = 0x0441;		/* color 4 - bleu */
      		*pw = 0x0f1f;		/* color 5 - bleu */
      		*pw = 0x0761;		/* color 6 - bleu */
      		*pw = 0x0b91;		/* color 7 - bleu */
      		*pw = 0x0093;		/* color 8 - black */
      		*pw = 0x0eb1;		/* color 9 - bleu */
      		*pw = 0x0f4f;		/* color A - bleu */
      		*pw = 0x0f6b;		/* color B -bleu */
      		*pw = 0x0ef6;		/* color C - bleu */
      		*pw = 0x0fee;		/* color D - bleu */
      		*pw = 0x0fff;		/* color E - bleu */
      		*pw = 0x0000;		/* color F - bleu */
          }
          else if (tempsmin==2 && tempssec==0)
          {
                  /*Dfinition de la 4eme palette (coco)*/
      		pl = (ulong *) GFXCNTL;
      		*pl = GFX_COLOR_WRITE_ADDR(96);
      		pw = (uint *) GFXDATA;

      		*pw = 0x0000;		/* color 0 - tran bleu */
      		*pw = 0x0726;		/* color 1 - white 0c10*/
      		*pw = 0x0932;		/* color 2 - black */
      		*pw = 0x0938;		/* color 3 - bleu */
      		*pw = 0x0231;		/* color 4 - bleu */
      		*pw = 0x0936;		/* color 5 - bleu */
      		*pw = 0x0442;		/* color 6 - bleu */
      		*pw = 0x0662;		/* color 7 - bleu */
      		*pw = 0x0254;		/* color 8 - black */
      		*pw = 0x0783;		/* color 9 - bleu */
      		*pw = 0x0c38;		/* color A - bleu */
      		*pw = 0x0c45;		/* color B -bleu */
      		*pw = 0x08c4;		/* color C - bleu */
      		*pw = 0x0d99;		/* color D - bleu */
      		*pw = 0x0ccc;		/* color E - bleu */
      		*pw = 0x0000;		/* color F - bleu */

          }

      if(pointspasses>9)
        {pointspasses=0;}

        
                 /*ecriture du chrono*/
                 pl = (ulong *) GFXCNTL;
                 *pl = GFX_WRITE_ADDR(0xC502);
                 pw = (uint *) GFXDATA;
                 for(i=0;i<2;i++)
                    {*pw = 0x8000 + (message[i+(tempsmin*2)]-32)+0x460 + (1 << 13);}  
                 *pw = 0x8000 + (message[i+(61*2)]-32)+0x460 + (1 << 13);
                 for(i=0;i<2;i++)
                    {*pw = 0x8000 + (message[i+(tempssec*2)]-32)+0x460 + (1 << 13);}
    
/*Affichage points &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/                

                 *pl = GFX_WRITE_ADDR(0xC602); /*D82-2944*/
                 pw = (uint *) GFXDATA;
                 for(i=0;i<2;i++)
                    {*pw = 0x8000 + (message[i+(pointsp1*2)]-32)+0x460 + (1 << 13);}

                 *pl = GFX_WRITE_ADDR(0xC64A); /*DCA-2944*/
                 pw = (uint *) GFXDATA;
                 for(i=0;i<2;i++)
                    {*pw = 0x8000 + (message[i+(pointsp2*2)]-32)+0x460 + (1 << 13);}


                 *pl = GFX_WRITE_ADDR(0xC626); /*DA6-2944*/
                 pw = (uint *) GFXDATA;
                 for(i=0;i<2;i++)
                    {*pw = 0x8000 + (message[i+(pointspasses*2)]-32)+0x460 + (1 << 13);}


                   if(pointsp1>19)
                      {
                      starsp1++;
                      *pl = GFX_WRITE_ADDR(0xCB1C);
                      pw = (uint *) GFXDATA;
                      for(i=0;i<10;i++)
                      {*pw = 0x8000 + (messagep1[i]-32)+0x460 + (1 << 13);}

                      *pl = GFX_WRITE_ADDR(0xC582);
                      pw = (uint *) GFXDATA;
                      for(i=0;i<starsp1;i++)
                      {*pw = 0x8000 + 0x46 +0x460 + (1 << 13);}

                        if(starsp1>7)
                          {
                            *pl = GFX_WRITE_ADDR(0xCB9C);
                            pw = (uint *) GFXDATA;
                            for(i=0;i<10;i++)
                            {*pw = 0x8000 + (messagegame[i]-32)+0x460 + (1 << 13);}
                            loop=1;
                          }

                      posx=150;
                      posy=300;
                      posx2=400;
                      posy2=300;
                      pointsp2=0;
                      pointsp1=0;
                      wait_sync(100);
                      }
                 else if(pointsp2>19)
                      {
                      starsp2++;
                      *pl = GFX_WRITE_ADDR(0xCB1C);
                      pw = (uint *) GFXDATA;
                      for(i=0;i<10;i++)
                      {*pw = 0x8000 + (messagep2[i]-32)+0x460 + (1 << 13);}

                      *pl = GFX_WRITE_ADDR(0xC5C0);
                      pw = (uint *) GFXDATA;
                      for(i=0;i<starsp2;i++)
                      {*pw = 0x8000 + 0x46 +0x460 + (1 << 13);}
                      
                        if(starsp2>7)
                          {
                            *pl = GFX_WRITE_ADDR(0xCB9C);
                            pw = (uint *) GFXDATA;
                            for(i=0;i<10;i++)
                            {*pw = 0x8000 + (messagegame[i]-32)+0x460 + (1 << 13);}
                            loop=1;
                          }

                      posx=150;
                      posy=300;
                      posx2=400;
                      posy2=300;
                      pointsp2=0;
                      pointsp1=0;
                      wait_sync(100);
                      }
                  else if (rotate==40)
                      {
                      *pl = GFX_WRITE_ADDR(0xCB1C);
                      pw = (uint *) GFXDATA;
                      for(i=0;i<10;i++)
                      {*pw = 0x8000 + (messagep2[4]-32)+0x460 + (1 << 13);}
                         if(automode==1)
                          {
                            *pl = GFX_WRITE_ADDR(0xC532);
                            pw = (uint *) GFXDATA;
                            for(i=0;i<15;i++)
                            {*pw = 0x8000 + (messagep2start[i]-32)+0x460 + (1 << 13);}
                          }
                         else
                          {
                            *pl = GFX_WRITE_ADDR(0xC532);
                            pw = (uint *) GFXDATA;
                            for(i=0;i<15;i++)
                            {*pw = 0x8000 + (messagep2start[2]-32)+0x460 + (1 << 13);}
                          }
                        }
                       else if (rotate==10)
                        {
                            *pl = GFX_WRITE_ADDR(0xC532);
                            pw = (uint *) GFXDATA;
                            for(i=0;i<15;i++)
                            {*pw = 0x8000 + (messagep2start[2]-32)+0x460 + (1 << 13);}
                        }

         wait_sync(1);
}
/*Si start est enfonc*/
else if(stop==1)
{

         if(kl!=32)
          {
          /*scroll plane vers le bas*/
          for (kl=72;kl>32;kl--)
           { 
            /* GFX scroll plane A */
            *pl = GFX_VERT_SCROLL(0xC000);
            *pw = kl-1;
            wait_sync(1);
           }
           }

      rotate++;
      if(rotate>3)
        {
        rotate=1;
        }
      wait_sync(10);

}
else if (stop==2)
{

          /*scroll plane vers le haut*/

            /* GFX scroll plane A */
            *pl = GFX_VERT_SCROLL(0xC000);
            *pw = 72;
kl=1;
stop=0;
if (automode==1)
 {automode=1;}
else
 {automode=0;}
      wait_sync(30);
}
else
{
kl=1;
stop=0;
if (automode==1)
 {automode=0;}
else
 {automode=1;}
wait_sync(20);
}

     }
   }


